﻿using System;
using System.Collections;
using System.Collections.Generic;
using Db4objects.Db4o;
using Db4objects.Db4o.Linq;
using System.Threading;

namespace HighScores
{
    public class HighScoreClient
    {
        public class Score
        {
            public int totalpts = 0;
            public int boats = 0;
            public int time =0;
            public int rus=0;
            public int ger=0;
            public int fre=0;
            public int miss=0;
            public int hits=0;
            public string name="none";
            public string cmptr="none";
            public string dt="unknown";

            public Score(Menus.Game.score s)
            {
                time = ((Menus.Game)RuskyRaiders.Program.menu[1]).time;

                if (s != null)
                {
                    totalpts = s.totalpts;
                    boats = s.boats;
                    miss = s.fired - s.hits;
                    hits = s.hits;
                    rus = s.russians;
                    ger = s.germans;
                    fre = s.french;
                }
                name = RuskyRaiders.Program.name;
                cmptr = System.Security.Principal.WindowsIdentity.GetCurrent().Name;
                dt = DateTime.Now.Month + "-" +
                    DateTime.Now.Day + "-" +
                    DateTime.Now.Year + " " +
                    DateTime.Now.Hour + ":" +
                    DateTime.Now.Minute + ":" +
                    DateTime.Now.Second;
            }

            public Score(int p, int b, int t, string n)
            {
                totalpts = p;
                boats = b;
                time = t;
                hits = boats * 3;
                name = n;
            }
        }

        private static string HOST = "209.252.168.136";
        private static int PORT = 6969;
        private static string USER = "wicky5787";
        private static string PASS = "upsilon";
        private static List<Score> defaults = new List<Score>();
        private static Score scoreToAdd;

        public static int HighScore = 10000;
        public static int Top3 = 10000;
        public static int Top5 = 10000;

        public static void setScore(Menus.Game.score addMe)
        {
            scoreToAdd = new Score(addMe);
        }

        public static void addHighScores()
        {
            IObjectContainer db = null;
            try
            { db = Db4oFactory.OpenClient(HOST, PORT, USER, PASS); }
            catch (Exception) { }

            if (db == null)
                db = Db4oFactory.OpenFile("LocalCache.dat");

            db.Store(scoreToAdd);
            db.Close();
        }

        public static string[] getHighScores()
        {
            IObjectContainer db = null;
            try
            { db = Db4oFactory.OpenClient(HOST, PORT, USER, PASS); }
            catch (Exception) { }

            string[] scores = new string[0];
            if (db != null)
            {//If connected to database server
                //Add local cache to server
                IObjectContainer local = Db4oFactory.OpenFile("LocalCache.dat");
                IObjectSet cache = local.QueryByExample(typeof(Score));
                foreach (Score s in cache)
                {
                    db.Store(s);
                    local.Delete(s);
                }
                local.Close();
                //End of local cache update
            }
            else
            {
                db = Db4oFactory.OpenFile("LocalCache.dat");
                scores = new string[1];
            }

            IEnumerable<Score> result = from Score s in db
                                        orderby s.totalpts descending
                                        select s;
            List<Score> res = new List<Score>(result);

            int i;
            if (scores.Length == 0)
            {
                scores = new string[res.Count];
                i = 0;
            }
            else
            {
                scores = new string[res.Count + 1];
                scores[0] = " Database server connection not established...";
                i = 1;
            }

            for (i = i+0; i < scores.Length; i++)
            {
                string acc = Math.Round(res[i].hits * 100.0 / (1.0 * res[i].miss + res[i].hits), 1) + "%";
                // Rank   Name                 Score           Time Left   Hits   Misses   Accuracy   Boats   Germans   French   Russians 
                //------ -------------------- --------------- ----------- ------ -------- ---------- ------- --------- -------- ----------
                scores[i] = "  " + (i + 1) + "     ".Substring(0, 6 - Convert.ToString(i + 1).Length) +
                    res[i].name + "                     ".Substring(0, 21 - res[i].name.Length) +
                    res[i].totalpts + "                ".Substring(0, 16 - Convert.ToString(res[i].totalpts).Length) +
                    res[i].time + "                ".Substring(0, 12 - Convert.ToString(res[i].time).Length) +
                    res[i].hits + "                ".Substring(0, 7 - Convert.ToString(res[i].hits).Length) +
                    res[i].miss + "                ".Substring(0, 9 - Convert.ToString(res[i].miss).Length) +
                    acc + "           ".Substring(0, 11 - acc.Length) +
                    res[i].boats + "                ".Substring(0, 8 - Convert.ToString(res[i].boats).Length) +
                    res[i].ger + "                ".Substring(0, 10 - Convert.ToString(res[i].ger).Length) +
                    res[i].fre + "                ".Substring(0, 9 - Convert.ToString(res[i].fre).Length) +
                    res[i].rus;
            }

            db.Close();

            return scores;
        }

        public static void resetHighScores()
        {
            IObjectContainer db = null;
            try
            { db = Db4oFactory.OpenClient(HOST, PORT, USER, PASS); }
            catch (Exception) { }

            if (db != null)
            {
                IObjectSet result = db.QueryByExample(typeof(Score));

                foreach (Object item in result)
                    db.Delete(item);

                setDefaults();
                foreach (Score s in defaults)
                    db.Store(s);

                db.Close();
            }
        }

        private static void setDefaults()
        {
            defaults.Add(new Score(10000, 10, 0, "Chuck Norris"));
            defaults.Add(new Score(9000, 9, 0, "Jesus"));
            defaults.Add(new Score(8000, 8, 0, "Bruce Springsteen"));
            defaults.Add(new Score(7000, 7, 0, "Steven Colbert"));
            defaults.Add(new Score(6000, 6, 0, "Wonder Woman"));
            defaults.Add(new Score(5000, 5, 0, "Peter Parker"));
            defaults.Add(new Score(1000, 4, 0, "Rosa Parks"));
            defaults.Add(new Score(500, 3, 0, "Bob Dylan"));
            defaults.Add(new Score(100, 2, 0, "George Bush"));
            defaults.Add(new Score(50, 1, 0, "Mahmoud Ahmadinejad"));

            foreach (Score s in defaults)
            {
                s.cmptr = "none";
                s.dt = "none";
            }
        }

        public static void watch()
        {
            Thread t = new Thread(new ThreadStart(updatePiers));
            t.Start();
        }

        private static void updatePiers()
        {
            while (true)
            {
                IObjectContainer db = null;
                try
                { db = Db4oFactory.OpenClient(HOST, PORT, USER, PASS); }
                catch (Exception) { }

                string[] scores = new string[0];
                if (db != null)
                {//If connected 
                    IEnumerable<Score> result = from Score s in db
                                                orderby s.totalpts descending
                                                select s;
                    List<Score> res = new List<Score>(result);

                    if (res.Count > 4)
                    {
                        HighScore = res[0].totalpts;
                        Top3 = res[2].totalpts;
                        Top5 = res[4].totalpts;
                    }

                    db.Close();
                }

                Thread.Sleep(45000);
            }
        }

        private static int ct = 0;
        public static string consoleColor(int i)
        {
            if (i >= HighScore)
            {
                ct = (ct+ i) % 21;
                return "rrrrrrr1111111bbbbbbbrrrrrr".Substring(ct, 7);;
            }
            else if (i >= Top3)
                return "rrrrrrr";
            else if (i >= Top5)
                return "bbbbbbb";
            else if (i >= 5000)
                return "1111111";
            else if (i >= 250)
                return "2222222";
            else
                return "3333333";
        }

        public static void highscorestofile()
        {
            IObjectContainer db = null;
            try
            { db = Db4oFactory.OpenClient(HOST, PORT, USER, PASS); }
            catch (Exception) { }

            string[] scores = new string[0];
            if (db != null)
            {//If connected to database server
                IEnumerable<Score> result = from Score s in db
                                            orderby s.dt descending
                                            select s;
                List<Score> res = new List<Score>(result);

                System.IO.StreamWriter outstr = new System.IO.StreamWriter("highscores.txt");
                foreach (Score s in res)
                {
                    outstr.WriteLine
                        (
                            s.cmptr + "\t" +
                            s.dt + "\t" +
                            s.name + "\t" +
                            s.totalpts + "\t" +
                            s.time + "\t" +
                            s.hits + "\t" +
                            s.miss + "\t" +
                            s.boats + "\t" +
                            s.rus + "\t" +
                            s.fre + "\t" +
                            s.ger
                        );
                }
                outstr.Close();
                db.Close();
            }

        }
    }
}
