﻿using System;
using System.IO;
using System.Threading;

namespace Graphics
{
    public class Defaults
    {
        public static ConsoleColor defaultForeground = ConsoleColor.Gray;
        public static ConsoleColor defaultBackground = ConsoleColor.Black;
        public static char defaultTransparencyKey = ' ';

        public static ConsoleColor getColor(char c)
        {
            switch (c)
            {
                case '1':
                    return ConsoleColor.White;
                case '2':
                    return ConsoleColor.Gray;
                case '3':
                    return ConsoleColor.DarkGray;
                case '4':
                    return ConsoleColor.Black;
                case 'r':
                    return ConsoleColor.Red;
                case 'R':
                    return ConsoleColor.DarkRed;
                case 'y':
                    return ConsoleColor.Yellow;
                case 'Y':
                    return ConsoleColor.DarkYellow;
                case 'g':
                    return ConsoleColor.Green;
                case 'G':
                    return ConsoleColor.DarkGreen;
                case 'b':
                    return ConsoleColor.Blue;
                case 'B':
                    return ConsoleColor.DarkBlue;
                case 'c':
                    return ConsoleColor.Cyan;
                case 'C':
                    return ConsoleColor.DarkCyan;
                case 'm':
                    return ConsoleColor.Magenta;
                case 'M':
                    return ConsoleColor.DarkMagenta;
            }

            return defaultBackground;
        }

        public static char getChar(ConsoleColor c)
        {
            switch (c)
            {
                case ConsoleColor.White:
                    return '1';
                case ConsoleColor.Gray:
                    return '2';
                case ConsoleColor.DarkGray:
                    return '3';
                case ConsoleColor.Black:
                    return '4';
                case ConsoleColor.Red:
                    return 'r';
                case ConsoleColor.DarkRed:
                    return 'R';
                case ConsoleColor.Yellow:
                    return 'y';
                case ConsoleColor.DarkYellow:
                    return 'Y';
                case ConsoleColor.Green:
                    return 'g';
                case ConsoleColor.DarkGreen:
                    return 'G';
                case ConsoleColor.Blue:
                    return 'b';
                case ConsoleColor.DarkBlue:
                    return 'B';
                case ConsoleColor.Cyan:
                    return 'c';
                case ConsoleColor.DarkCyan:
                    return 'C';
                case ConsoleColor.Magenta:
                    return 'm';
                case ConsoleColor.DarkMagenta:
                    return 'M';
            }

            return '\0';
        }

        public static string[] fileToStringArray(string path)
        {
            try
            {
                StreamReader inFile;
                int i;

                //Count number of lines
                i = 0;
                inFile = new StreamReader(path);
                while (!inFile.EndOfStream)
                {
                    inFile.ReadLine();
                    i++;
                }
                inFile.Close();

                //Write each line to a string array
                string[] lines = new string[i];
                i = 0;
                inFile = new StreamReader(path);
                while (!inFile.EndOfStream)
                {
                    lines[i] = inFile.ReadLine();
                    i++;
                }

                return lines;
            }
            catch (Exception) { }

            return null;
        }

        public static void printText(string[] s, int x, int y, int rand)
        {
            Console.CursorVisible = true;

            int i = 0;
            int j = 0;
            int z = 0;
            char[] randy = "j&Q@n%@#&@Q^@u&S*^gyX#e@D+#rD/Q*&*c@!h*Z^$X S!A*/-+".ToCharArray();

            foreach (string w in s)
            {
                foreach (char c in w)
                {
                    if (c != '`')
                    {
                        for (int m = 0; m < rand; m++)
                        {
                            Console.SetCursorPosition(x + i, y + j);
                            Console.Write(randy[(++z) % randy.Length]);
                        }
                        Console.SetCursorPosition(x + i, y + j);
                        Console.Write(c);
                        System.Threading.Thread.Sleep(15);
                    }
                    i++;
                }
                i = 0;
                j++;
            }


            Console.CursorVisible = false;
        }
    }
}

