﻿using System;
using System.Collections.Generic;

namespace Graphics
{
    /// <summary>
    /// Represents an animation implementation of a Sprite
    /// </summary>
    public class MainMenuAnimation : Layer
    {
        public List<Sprite> animations = new List<Sprite>();

        public MainMenuAnimation()
        {
            Console.Write("Background Animation - 0%");
            /*US Ship*/

            Animation USA_R = new Animation(@"Graphics\Library\Boats\Boat_USA_R");
            Animation USA_L = new Animation(@"Graphics\Library\Boats\Boat_USA_L");
            setPath(-20, 50, 30, 50, 45, USA_R);
            setPath(-20, -20, -20, -20, 45, USA_L);

            setPath(30, 51, 5, 51, 25, USA_L);
            setPath(-20, -20, -20, -20, 25, USA_R);

            setPath(5, 52, 10, 52, 5, USA_R);
            setPath(10, 52, 10, 52, 40, USA_R);
            setPath(-20, -20, -20, -20, 45, USA_L);

            setPath(10, 52, 70, 52, 60, USA_R);
            setPath(70, 52, 90, 52, 30, USA_R);
            setPath(-20, -20, -20, -20, 90, USA_L);

            setPath(90, 51, 70, 49, 80, USA_L);
            setPath(-20, -20, -20, -20, 80, USA_R);

            setPath(70, 49, 94, 48, 90, USA_R);
            setPath(-20, -20, -20, -20, 90, USA_L);

            setPath(94, 48, 94, 48, 30, USA_L);
            setPath(-20, -20, -20, -20, 30, USA_R);

            setPath(94, 48, -20, 53, 70, USA_L);
            setPath(-20, -20, -20, -20, 70, USA_R);

            setPath(-20, -20, -20, -20, 30, USA_R);
            setPath(-20, -20, -20, -20, 30, USA_L);

            setPath(30, 62, 40, 53, 70, USA_R);
            setPath(-20, -20, -20, -20, 70, USA_L);

            setPath(40, 53, 40, 53, 50, USA_R);
            setPath(-20, -20, -20, -20, 50, USA_L);

            setPath(40, 53, 5, 46, 20, USA_L);
            setPath(-20, -20, -20, -20, 20, USA_R);

            setPath(5, 46, 40, 49, 20, USA_R);
            setPath(-20, -20, -20, -20, 20, USA_L);

            setPath(40, 50, 7, 55, 20, USA_L);
            setPath(-20, -20, -20, -20, 20, USA_R);

            setPath(7, 55, 48, 43, 20, USA_R);
            setPath(-20, -20, -20, -20, 20, USA_L);

            setPath(48, 43, 12, 50, 20, USA_L);
            setPath(-20, -20, -20, -20, 20, USA_R);

            setPath(12, 50, 32, 51, 20, USA_R);
            setPath(-20, -20, -20, -20, 20, USA_L);

            setPath(32, 51, 52, 52, 30, USA_R);
            setPath(-20, -20, -20, -20, 30, USA_L);

            setPath(52, 52, 52, 52, 50, USA_R);
            setPath(-20, -20, -20, -20, 50, USA_L);

            setPath(52, 52, -20, 47, 40, USA_L);
            setPath(-20, -20, -20, -20, 40, USA_R);

            setPath(-20, -20, -20, -20, 400, USA_R);
            setPath(-20, -20, -20, -20, 400, USA_L);

            animations.Add(USA_R);
            animations.Add(USA_L);

            Console.CursorLeft = Console.CursorLeft - 2;
            Console.Write("15%");
            /*End of US Ship*/

            /*USSR Ship*/
            Animation Russ_L = new Animation(@"Graphics\Library\Boats\Boat_Russian_L");
            Animation Russ_R = new Animation(@"Graphics\Library\Boats\Boat_Russian_R");
            setPath(120, 52, 94, 50, 55, Russ_L);
            setPath(-20, -20, -20, -20, 55, Russ_R);

            setPath(94, 50, 100, 49, 30, Russ_R);
            setPath(-20, -20, -20, -20, 30, Russ_L);

            setPath(100, 49, 100, 49, 30, Russ_L);
            setPath(-20, -20, -20, -20, 30, Russ_R);

            setPath(-20, -20, -20, -20, 1265 - Russ_L.xPs.Count, Russ_L);
            setPath(-20, -20, -20, -20, 1265 - Russ_R.xPs.Count, Russ_R);

            animations.Add(Russ_L);
            animations.Add(Russ_R);

            Animation sinkR = new Animation(@"Graphics\Library\Boats\Boat_Russian_L_Sink");
            sinkR.repeat = true;
            setPath(100, 49, 100, 49, sinkR.frames.Count, sinkR);
            setFramesWait(105, sinkR);
            setFramesPath(150, 80, 150, 80, 1265 - sinkR.frames.Count, sinkR);

            animations.Add(sinkR);

            Console.CursorLeft = Console.CursorLeft - 3;
            Console.Write("30%");
            /*End of USSR Ship*/

            /*French Ship*/
            Animation Fre_L = new Animation(@"Graphics\Library\Boats\Boat_French_L");
            Animation Fre_R = new Animation(@"Graphics\Library\Boats\Boat_French_R");

            setPath(-20, -20, -20, -20, 285, Fre_L);
            setPath(-20, -20, -20, -20, 285, Fre_R);

            setPath(40, 60, 20, 50, 90, Fre_L);
            setPath(-20, -20, -20, -20, 90, Fre_R);

            Animation ah = new Animation();
            ah.image = new string[1];
            ah.image[0] = @"|/";
            ah.frames.Add(ah.image);

            setPath(-20, -20, -20, -20, 375, ah);
            setPath(28, 50, 28, 50, 25, ah);
            setPath(-20, -20, -20, -20, 865, ah);

            setPath(20, 50, 20, 50, 15, Fre_R);
            setPath(-20, -20, -20, -20, 15, Fre_L);

            setPath(20, 50, -20, 54, 40, Fre_L);
            setPath(-20, -20, -20, -20, 40, Fre_R);

            setPath(120, 42, 90, 48, 70, Fre_L);
            setPath(-20, -20, -20, -20, 70, Fre_R);

            setPath(90, 48, 100, 49, 60, Fre_R);
            setPath(-20, -20, -20, -20, 60, Fre_L);

            setPath(100, 49, 100, 49, 180, Fre_R);
            setPath(-20, -20, -20, -20, 180, Fre_L);

            setPath(-20, -20, -20, -20, 525, Fre_R);
            setPath(-20, -20, -20, -20, 525, Fre_L);

            Animation sinkF = new Animation(@"Graphics\Library\Boats\Boat_French_R_Sink");
            sinkF.repeat = true;
            setPath(100,49,100,49,sinkF.frames.Count,sinkF);
            setFramesWait(740, sinkF);
            setFramesPath(-20, -20, -20, -20, 1265 - sinkF.frames.Count, sinkF);

            animations.Add(Fre_L);
            animations.Add(Fre_R);
            animations.Add(ah);
            animations.Add(sinkF);

            Console.CursorLeft = Console.CursorLeft - 3;
            Console.Write("45%");
            /*End of French Ship*/

            /*German*/
            Animation GerL = new Animation(@"Graphics\Library\Boats\Sub_German_L");
            Animation GerR = new Animation(@"Graphics\Library\Boats\Sub_German_R");
            GerL.repeat = true;
            GerR.repeat = true;
            setPath(80, 40, 40, 42, GerL.frames.Count, GerL);
            setPath(40, 44, 80, 46, GerR.frames.Count, GerR);
            
            setFramesWait(838, GerL);
            setFramesWait(GerL.frames.Count, GerR);
            
            setFramesPath(-20, -20, -20, -20, 1265 - GerL.frames.Count, GerL);
            setFramesPath(-20, -20, -20, -20, 1265 - GerR.frames.Count, GerR);

            animations.Add(GerL);
            animations.Add(GerR);

            //torpedos!!!
            Animation torp1 = new Animation(@"Graphics\Library\torp_L",58,41);
            Animation torp2 = new Animation(@"Graphics\Library\torp_R",64,44);
            torp1.flipped = true;
            torp1.setTorpedoPath(torp1);
            torp2.setTorpedoPath(torp2);
            setFramesWait(940, torp1);
            setFramesWait(1100, torp2);
            setFramesPath(-20, -20, -20, -20, 1265 - torp1.frames.Count, torp1);
            setFramesPath(-20, -20, -20, -20, 1265 - torp2.frames.Count, torp2);
            torp1.repeat = true;
            torp2.repeat = true;
            animations.Add(torp1);
            animations.Add(torp2);

            Console.CursorLeft = Console.CursorLeft - 3;
            Console.Write("60%");
            /*End of German*/

            /*Cannonballs*/
            addBall(10, 52, 100, 52, 73);

            //Miss
            Animation ball1 = new Graphics.Animation();
            ball1.setCannonBallPath(50, 54, 94, 54);
            ball1.repeat = true;
            setFramesWait(580, ball1);
            setFramesPath(150, 80, 150, 80, 1265 - ball1.frames.Count, ball1);
            animations.Add(ball1);

            //Rampage
            Random rand = new Random();
            Console.CursorLeft = Console.CursorLeft - 3;
            Console.Write("75%");
            addBall(getX(630) + 12 + rand.Next(4), getY(630)+1, rand.Next(100,111), rand.Next(49,55), 630);
            addBall(getX(635) + 12 + rand.Next(4), getY(635)+1, rand.Next(100,111), rand.Next(49,55), 635);
            addBall(getX(640) + 12 + rand.Next(4), getY(640)+1, rand.Next(100,111), rand.Next(49,55), 640);
            addBall(getX(645) + 12 + rand.Next(4), getY(645)+1, rand.Next(100,111), rand.Next(49,55), 645);
            addBall(getX(654) + 12 + rand.Next(4), getY(654)+1, rand.Next(100,111), rand.Next(49,55), 654);
            addBall(getX(655) + 12 + rand.Next(4), getY(655)+1, rand.Next(100,111), rand.Next(49,55), 655);
            addBall(getX(660) + 12 + rand.Next(4), getY(660)+1, rand.Next(100,111), rand.Next(49,55), 660);
            addBall(getX(662) + 12 + rand.Next(4), getY(662)+1, rand.Next(100,111), rand.Next(49,55), 662);
            addBall(getX(669) + 12 + rand.Next(4), getY(669)+1, rand.Next(100,111), rand.Next(49,55), 669);
            addBall(getX(673) + 12 + rand.Next(4), getY(673)+1, rand.Next(100,111), rand.Next(49,55), 673);
            addBall(getX(680) + 12 + rand.Next(4), getY(680)+1, rand.Next(100,111), rand.Next(49,55), 680);
            Console.CursorLeft = Console.CursorLeft - 3;
            Console.Write("90%");
            addBall(getX(681) + 12 + rand.Next(4), getY(681)+1, rand.Next(100,111), rand.Next(49,55), 681);
            addBall(getX(683) + 12 + rand.Next(4), getY(683)+1, rand.Next(100,111), rand.Next(49,55), 683);
            addBall(getX(689) + 12 + rand.Next(4), getY(689)+1, rand.Next(100,111), rand.Next(49,55), 689);
            addBall(getX(691) + 12 + rand.Next(4), getY(691)+1, rand.Next(100,111), rand.Next(49,55), 691);
            addBall(getX(698) + 12 + rand.Next(4), getY(698)+1, rand.Next(100,111), rand.Next(49,55), 698);
            addBall(getX(699) + 12 + rand.Next(4), getY(699)+1, rand.Next(100,111), rand.Next(49,55), 699);
            addBall(getX(700) + 12 + rand.Next(4), getY(700)+1, rand.Next(100,111), rand.Next(49,55), 700);
            addBall(getX(701) + 12 + rand.Next(4), getY(701)+1, rand.Next(100,111), rand.Next(49,55), 701);
            addBall(getX(702) + 12 + rand.Next(4), getY(702)+1, rand.Next(100,111), rand.Next(49,55), 702);
            addBall(getX(703) + 12 + rand.Next(4), getY(703)+1, rand.Next(100,111), rand.Next(49,55), 703);
            addBall(getX(715) + 12 + rand.Next(4), getY(715)+1, rand.Next(100,111), rand.Next(49,55), 715);

            /*End of Cannonballs*/
            Console.CursorLeft = Console.CursorLeft - 5;
            Console.WriteLine("created");
        }

        private void setPath(int x, int y, int i, int j, int frames, Animation a)
        {
            for (int c = 1; c <= frames; c++)
            {
                a.xPs.Add(x + ((i - x) * c / frames));
                a.yPs.Add(y + ((j - y) * c / frames));
            }
        }

        private void setWait(int frames, Animation a)
        { 
            LinkedList<int> x = new LinkedList<int>(a.xPs);
            LinkedList<int> y = new LinkedList<int>(a.yPs);

            for (int i = 0; i < frames; i++)
            {
                x.AddFirst(150);
                y.AddFirst(80);
            }

            a.xPs = new List<int>(x);
            a.yPs = new List<int>(y);
        }

        private void setFramesPath(int x, int y, int i, int j, int frames, Animation a)
        {
            setPath(x, y, i, j, frames, a);

            string[] blank = { "" };
            for (int c = 1; c <= frames; c++)
            {
                a.frames.Add(blank);
                a.solids.Add(blank);
            }
        }

        private void setFramesWait(int frames, Animation a)
        {
            setWait(frames, a);

            LinkedList<string[]> x = new LinkedList<string[]>(a.frames);
            LinkedList<string[]> y = new LinkedList<string[]>(a.solids);
            string[] blank = {""};
            for (int i = 0; i < frames; i++)
            {
                x.AddFirst(blank);
                y.AddFirst(blank);
            }

            a.frames = new List<String[]>(x);
            a.solids = new List<String[]>(y);
        }

        private void addBall(int x, int y, int i, int j, int time)
        {
            Animation ball1 = new Graphics.Animation();
            ball1.setCannonBallPath(x, y, i, j);

            Animation exp1 = new Graphics.Animation(@"Graphics\Library\Explosion");
            setPath(i - 3, j - 4, i - 3, j - 4, exp1.frames.Count, exp1);

            setFramesWait(time + ball1.frames.Count, exp1);
            setFramesWait(time, ball1);
            
            setFramesPath(-20, -20, -20, -20, 1265 - exp1.frames.Count, exp1);
            setFramesPath(-20, -20, -20, -20, 1265 - ball1.frames.Count, ball1);
            
            ball1.repeat = true;
            exp1.repeat = true;
            
            animations.Add(ball1);
            animations.Add(exp1);
        }

        private int getX(int time)
        {
            if (((Animation)animations[0]).xPs[time] > 0 && ((Animation)animations[0]).xPs[time] < 120)
                return ((Animation)animations[0]).xPs[time];
            else
                return ((Animation)animations[1]).xPs[time];
        }

        private int getY(int time)
        {
            if (((Animation)animations[0]).yPs[time] > 0 && ((Animation)animations[0]).yPs[time] < 60)
                return ((Animation)animations[0]).yPs[time];
            else
                return ((Animation)animations[1]).yPs[time];
        }
    }
}

