﻿using System;
using Graphics;
using System.Diagnostics;
using System.Threading;
using System.Collections.Generic;

namespace Menus
{
    public partial class Game : GameLayer
    {
        //protected Layer buffer;
        //protected Sprite cursor1;
        //protected Sprite cursor2;
        //protected bool exit = false;
        //public LayerArgs msg = new LayerArgs();
        private Still boat;
        private List<Sprite> enemies;
        private List<Sub> subs;
        private List<Animation> balls;
        private Sprite boatToFire;
        private Animation scoreDis; 

        private int fireMax, fireMin, fireCt, uvbeenhit;
        public int level, time, cursorWatch, enemyClock;
        private bool fire, timeEnforced;

        public class score
        {
            public int totalpts=0;
            public int boats=0;
            public int hits=0;
            public int fired=0;
            public int russians=0;
            public int french=0;
            public int germans=0;
        }
        public class alldata
        { 
            public score lev;
            public score tot;
        }
        public score levelscore = new score();
        public score totalscore = new score();

        public Game(){ reset(); }

        private void reset()
        {
            level = 1;

            scoreDis = new Animation();
            scoreDis.image = new string[1];
            scoreDis.fcolor = new string[1];
            scoreDis.hasColor = true;
            scoreDis.yP = 59;
            scoreDis.xP = 120;

            fire = false;    //determines whether enemies fire (firezemissiles() method)
            fireMax = 200;  //Max frames in random number generator (RNG) to wait for next enemy to fire
            fireMin = 70;   //Min frames in RNG to wait before next enemy fires
            fireCt = 100;   //Counter initial value.  Will wait fireCt frames at start of level before firing.  This will be set between min/max after first fire.
            
            uvbeenhit = 0;  //Stun Counter used if you're hit
            timeEnforced = true;    //If you run out of time or fail level 16, you can continue your progress with 0 secs of time bonus
            enemyClock = 0; //Counter used to wait before moving enemies

            time = 15; 
            cursorWatch = 0; //Used to make the Aimer disappear after X frames
            levelscore = new score();
            totalscore = new score();
        }

        public override void runLayer(LayerArgs sender)
        {
            setLevel(level);                     //Adds all enemy boats for this level to the buffer
            Console.Clear();                  
            if (level == 21)
            {
                reset();
                return;
            }

            buffer.image = new char[120,60];     //Causes a repaint of the buffer
            bool exit = false;                   //Used to exit the game loop
            Stopwatch clock = new Stopwatch();   //Used to keep a constant framerate
            int endcounter = 80;                //Number of frames to display after last enemy has been destroyed

            while (!exit)
            { //Begin Loop
                uvbeenhit = Math.Max(0, uvbeenhit - 1);
                if (Console.KeyAvailable)
                { //Begin Key Detection
                    if (uvbeenhit != 0)
                        Console.ReadKey(true);
                    else
                    {
                        switch (Console.ReadKey(true).Key)
                        {
                            //Move your boat
                            case ConsoleKey.UpArrow:
                                move(boat, 0, -1);
                                break;
                            case ConsoleKey.DownArrow:
                                move(boat, 0, 1);
                                break;
                            case ConsoleKey.RightArrow:
                                move(boat, 1, 0);
                                break;
                            case ConsoleKey.LeftArrow:
                                move(boat, -1, 0);
                                break;

                            //Move aimer
                            case ConsoleKey.A:
                                cursor1.xP = Math.Max(cursor1.xP - 1, 0);
                                if (cursor1.disabled)
                                    buffer.add(cursor1);
                                cursorWatch = 0;
                                cursor1.disabled = false;
                                break;
                            case ConsoleKey.S:
                                cursor1.yP = Math.Min(cursor1.yP + 1, 57);
                                if (cursor1.disabled)
                                    buffer.add(cursor1);
                                cursorWatch = 0;
                                cursor1.disabled = false;
                                break;
                            case ConsoleKey.D:
                                cursor1.xP = Math.Min(cursor1.xP + 1, 117);
                                if (cursor1.disabled)
                                    buffer.add(cursor1);
                                cursorWatch = 0;
                                cursor1.disabled = false;
                                break;
                            case ConsoleKey.W:
                                cursor1.yP = Math.Max(cursor1.yP - 1, 0);
                                if (cursor1.disabled)
                                    buffer.add(cursor1);
                                cursorWatch = 0;
                                cursor1.disabled = false;
                                break;
                            //Toggle Mute
                            case ConsoleKey.M:
                                Sound.Player.mute = !Sound.Player.mute;
                                break;
                            //Toggle PC speaker/soundcard
                            case ConsoleKey.N:
                                if (Sound.Player.availableSoundCard)
                                    Sound.Player.useSoundCard = !Sound.Player.useSoundCard;
                                break;
                            //Pause
                            case ConsoleKey.Escape:
                            case ConsoleKey.P:
                                Console.SetCursorPosition(55, 29);
                                Console.Write("**********");
                                Console.SetCursorPosition(55, 30);
                                Console.Write("* PAUSED *");
                                Console.SetCursorPosition(55, 31);
                                Console.Write("**********");
                                for (int i=55; i<65; i++)
                                    for (int j = 29; j<32; j++)
                                        buffer.image[i,j] = '.';

                                bool paused = true;
                                ConsoleKey a = ConsoleKey.A;
                                while(paused)
                                {
                                    if (Console.KeyAvailable)
                                        a = Console.ReadKey(true).Key;
                                    if (a.Equals(ConsoleKey.Escape) || a.Equals(ConsoleKey.P))
                                        paused = false;
                                    Thread.Sleep(30);
                                }
                                break;
                            case ConsoleKey.Spacebar:
                            case ConsoleKey.F:
                                levelscore.fired++;
                                buffer.add((new Animation()).setCannonBallPath(boat.xP + 12, boat.yP + 1, cursor1.xP + 1, cursor1.yP + 1));
                                balls.Add((Animation)buffer.items[buffer.items.Count - 1]);
                                break;
                        }
                    }
                }//End Key Detection

                //Check for Aimer timeout
                if (cursorWatch++ == 20)
                    cursor();
                if (cursorWatch == Int32.MaxValue)
                    cursorWatch = 0;

                //Check for cannonball strike
                cannonballCheck();
                
                //Move enemies
                moveEnemies();

                //Fire!
                if (fire)
                    fireZeMissles();

                //Print buffer to screen
                buffer.readyPrint();
                clock.Stop();
                if (clock.Elapsed.Milliseconds < 30)
                    Thread.Sleep(30 - clock.Elapsed.Milliseconds);
                clock.Reset();
                clock.Start();
                buffer.print();

                //Print Timer - Check fail conditions
                if (timeEnforced)
                    if (inctimer())
                        return;

                //Print score and level info
                    if (timeEnforced)
                        Console.Write(" Level " + level);
                    else
                    {
                        Console.SetCursorPosition(0, 59);
                        Console.Write(" Level " + level);
                    }
                    Console.SetCursorPosition(112 - Convert.ToString(totalscore.totalpts).Length, 59);
                    Console.Write("Score: ");
                    scoreDis.xP = 119 - Convert.ToString(totalscore.totalpts).Length;
                    scoreDis.image[0] = Convert.ToString(totalscore.totalpts);
                    scoreDis.fcolor[0] = HighScores.HighScoreClient.consoleColor(totalscore.totalpts);   
                //End of print score and level info

                //Check Success Conditions
                if (checkExitConditions())
                    exit = endcounter-- == 0;
                    
            } //End Loop


            //Update Total Score
            updateTotal();


            //If you succeed and need to move on to the next level
            msg.dataS = "Level " + level + " Complete!";
            msg.dataI = level++;
            Menus.Game.alldata temp = new Menus.Game.alldata();
            temp.lev = levelscore;
            temp.tot = totalscore;
            msg.obj = temp;
            msg.nextLayerIndex = 1;
            if (level == 21)
            {
                msg.nextLayerIndex = 4;
                RuskyRaiders.Program.menu[7].runLayer(msg);
                HighScores.HighScoreClient.setScore(totalscore);
                Thread th1 = new Thread(new ThreadStart(HighScores.HighScoreClient.addHighScores));
                th1.Start();
                reset();
                return;
            }
            RuskyRaiders.Program.menu[7].runLayer(msg);
        }

        /// <summary>
        /// Moves the Sprite "s" up, down, left, or right
        /// 
        /// Does not move if 'boat' collides with anything in the buffer
        /// Does not move if the boat will go off the screen.
        /// </summary>
        /// <param name="x"></param>
        /// <param name="y"></param>
        private void move(Sprite s, int x, int y)
        {
            if (x == 0)
            {
                if (y == 1)
                {
                    if (s.yP + 1 < 60 - s.image.Length)
                    {
                        s.yP++;
                        if (s.collision(buffer.items) == null)
                        {
                            //Move Down
                            if (s.Equals(boat))
                            {
                                cursor1.yP = Math.Min(cursor1.yP + 1, 57);
                            }
                        }
                        else
                            s.yP--;
                    }
                }
                else
                {
                    if (s.yP - 1 > 0)
                    {
                        s.yP--;
                        if (s.collision(buffer.items) == null)
                        {
                            //Move Up
                            if (s.Equals(boat))
                            {
                                cursor1.yP = Math.Max(cursor1.yP - 1, 0);
                            }
                        }
                        else
                            s.yP++;
                    }
                }
            }
            else
            {
                if (x == 1)
                {
                    if (s.xP + 1 < 120 - s.image[0].Length)
                    {
                        s.xP++;
                        if (s.collision(buffer.items) == null)
                        {
                            //Move Right
                            s.changeImage(s.flipped, s._path + "_R");
                            if (s.Equals(boat))
                                cursor1.xP = Math.Min(cursor1.xP + 1, 117);
                        }
                        else
                            s.xP--;
                    }
                }
                else
                {
                    if (s.xP - 1 > 0)
                    {
                        s.xP--;
                        if (s.collision(buffer.items) == null)
                        {
                            //Move Left
                            s.changeImage(!s.flipped, s._path + "_L");
                            if (s.Equals(boat))
                                cursor1.xP = Math.Max(cursor1.xP - 1, 0);
                        }
                        else
                            s.xP++;
                    }
                }
            }
        }

        /// <summary>
        /// Moves enemies
        /// </summary>
        private void moveEnemies()
        {
            if (++enemyClock == Int32.MaxValue)
                enemyClock = 0;

            Random rand = new Random();
            int i = 0;
            foreach (Sprite e in enemies)
            {
                i++;
                if (enemyClock % (100 / e.speed) == i)  //If it is the enemy's turn to move
                {
                    if (false)                               
                    {//If this is a scared French ship

                    }
                    else if (e._path.Contains("Boat"))
                    {//If this is a regular boat (not sub)
                        switch (rand.Next(8))           //Choose any direction or wait, with the 
                        {                               //current left/right direction 5 times more likely
                            case 0:
                            case 1:
                            case 2:
                            case 3:
                            case 4:
                                if (e.flipped)
                                    move(e, -1, 0);
                                else
                                    move(e, 1, 0);
                                break;
                            case 5:
                                if (e.flipped)
                                    move(e, 1, 0);
                                else
                                    move(e, -1, 0);
                                break;
                            case 6:
                                move(e, 0, 1);
                                break;
                            case 7:
                                move(e, 0, -1);
                                break;
                            case 8:
                                move(e, 0, 0);
                                break;
                        }
                    }
                    else if (e._path.Contains("Sub"))
                    {//This is a sub
                        Sub s = (Sub) e;
                        s.move(buffer.items);
                    }
                }
            }
        }

        /// <summary>
        /// Adds this level's score to the total
        /// </summary>
        private void updateTotal()
        {
            //Adjust level score for hits/misses
            totalscore.boats += levelscore.boats;
            totalscore.french += levelscore.french;
            totalscore.germans += levelscore.germans;
            totalscore.hits += levelscore.hits;
            totalscore.fired += levelscore.fired;
            totalscore.russians += levelscore.russians;
        }

        /// <summary>
        /// Reset Level Score
        /// </summary>
        private void resetLevelScore()
        {
            levelscore.boats = 0;
            levelscore.french = 0;
            levelscore.germans = 0;
            levelscore.hits = 0;
            levelscore.fired = 0;
            levelscore.russians = 0;
            levelscore.totalpts = 0;
        }

        /// <summary>
        /// Checks all cannonballs for hits
        /// </summary>
        private void cannonballCheck()
        {
            for (int i=0; i<balls.Count; i++)
            {
                Animation c = balls[i];


                if (c.counter >= c.frames.Count - 4 || (!c.image[0].Contains("o") && c.counter > 6))
                {
                    Sprite hit = c.collision(enemies);
                    if (hit != null)
                    {
                        c.disabled = true;
                        levelscore.hits++;

                        if (--hit.health == 0 && !hit.Equals(boat))
                        {
                            //You sunk their battleship!
                            levelscore.boats++;
                            if (hit._path.Contains("Sub"))
                                levelscore.germans++;
                            else if (hit._path.Contains("French"))
                                levelscore.french++;
                            else if (hit._path.Contains("Russian"))
                                levelscore.russians++;
                            levelscore.totalpts += hit.points;
                            totalscore.totalpts += hit.points;

                            Animation sinking;
                            if (hit.flipped)
                                sinking = new Animation(hit._path + "_L" + "_Sink");
                            else
                                sinking = new Animation(hit._path + "_R" + "_Sink");

                            sinking.xP = hit.xP;
                            sinking.yP = hit.yP;
                            sinking.repeat = false;
                            buffer.add((Sprite)sinking);
                            hit.disabled = true;
                        }

                        //Add explosion of cannonball
                        levelscore.totalpts += c.points;
                        totalscore.totalpts += c.points;
                        Animation explosion = new Animation(@"Graphics\Library\Explosion");
                        explosion.xP = c.xP - 3;
                        explosion.yP = c.yP - 5;
                        explosion.repeat = false;
                        buffer.add(explosion);
                    }

                    if (c.collision(boat))
                    {//Pause your boat
                        c.disabled = true;
                        uvbeenhit = 43;
                        buffer.add(new Animation(@"Graphics\Library\Stars", boat.xP + (boat.image[0].Length/2) - 2, boat.yP-3));
                        
                        //Add explosion of cannonball
                        if (c.solid[0] != "XXX")
                        {
                            Animation explosion = new Animation(@"Graphics\Library\Explosion");
                            explosion.xP = c.xP - 3;
                            explosion.yP = c.yP - 5;
                            explosion.repeat = false;
                            buffer.add(explosion);
                            uvbeenhit = 43;
                        }
                        else
                        {
                            Animation explosion = new Animation(@"Graphics\Library\Explosion1");
                            explosion.xP = c.xP - 4;
                            explosion.yP = c.yP - 5;
                            explosion.repeat = false;
                            buffer.add(explosion);
                            uvbeenhit = 93;
                        }
                    }
                }

                if (c.disabled)
                {
                    balls.Remove(c);
                    i--;
                }
            }
        }

        /// <summary>
        /// Checks ending conditions
        /// </summary>
        /// <returns></returns>
        private bool checkExitConditions()
        {
            for (int i = 0; i < enemies.Count; i++)
                if (enemies[i].disabled)
                    enemies.Remove(enemies[i--]);

            return enemies.Count == 0;
        }

        /// <summary>
        /// Changes the color of the aimer using a patriotic theme
        /// </summary>
        private void cursor()
        {
            cursor1.disabled = true;
            switch (cursor1.foregroundColor)
            {
                case ConsoleColor.Red:
                    cursor1.foregroundColor = ConsoleColor.White;
                    break;
                case ConsoleColor.White:
                    cursor1.foregroundColor = ConsoleColor.Blue;
                    break;
                case ConsoleColor.Blue:
                    cursor1.foregroundColor = ConsoleColor.Red;
                    break;
            }
        }

        /// <summary>
        /// Decrements the clock and prints it to screen.  Calls fail screen.
        /// </summary>
        /// <returns></returns>
        private bool inctimer()
        {
            bool youLoose = false;
            if (level == 16)
                if (cursor2.disabled && cursor2.health > 0)
                    youLoose = true;

            //If you fail
            if ((enemyClock % 40 == 0 && time-- == 0) || youLoose)
            {
                time = 0;
                msg.dataS = "Mission Failure";
                Menus.Game.alldata temp = new Menus.Game.alldata();
                updateTotal();
                temp.tot = totalscore;
                temp.lev = levelscore;
                msg.obj = temp;
                int temp1 = level;
                
                RuskyRaiders.Program.menu[7].runLayer(msg);

                if (msg.nextLayerIndex == 4)
                {
                    HighScores.HighScoreClient.setScore(totalscore);
                    Thread th1 = new Thread(new ThreadStart(HighScores.HighScoreClient.addHighScores));
                    th1.Start();
                    reset();
                    return true;
                }

                reset();
                level = temp1;
                return true;
            }
            //Print Time
            string t = " ";
            t += time / 60 + ":";
            if ((time % 60) / 10 == 0)
                t += "0";
            t += time % 60 + " ";

            if (time > 15)
                Console.ForegroundColor = ConsoleColor.DarkGreen;
            else if (time > 10)
                Console.ForegroundColor = ConsoleColor.Yellow;
            else
                Console.ForegroundColor = ConsoleColor.Red;

            Console.SetCursorPosition(0,59);
            Console.Write(t);
            Console.ForegroundColor = Graphics.Defaults.defaultForeground;       

            return false;
        }

        /// <summary>
        /// Fires Missles!
        /// </summary>
        private void fireZeMissles()
        {
            fireCt = Math.Max(0, fireCt-1);
            if (enemies.Count == 0)
                return;

            //Pick a boat that will fire
            Random rand = new Random();
            if (boatToFire == null)
                boatToFire = enemies[rand.Next(enemies.Count-1)];
            if (boatToFire.disabled)
                boatToFire = enemies[rand.Next(enemies.Count - 1)];

            //FIRE!
            if (fireCt == 0)
            {
                if (boatToFire._path.Contains("Sub"))
                {//if this is a sub 
                    if (boatToFire.image[0] != "??????????????")
                    {//If the sub is surfaced
                        Sub s = (Sub) boatToFire;
                        Animation torp = new Animation(@"Graphics\Library\torp"+s.flip, s.xP+5, s.yP+3);
                        torp.flipped = s.flipped;
                        torp.setTorpedoPath(boatToFire);
                        buffer.add(torp);
                        balls.Add(torp);

                        fireCt = Math.Max(2*rand.Next(fireMin, fireMax) / enemies.Count, fireMin);
                        boatToFire = enemies[rand.Next(enemies.Count - 1)];
                    }
                }
                else if (boatToFire._path.Contains("Boat"))
                {//if this is a boat
                    //Fire ze CannonBall!
                    buffer.add((new Animation()).setCannonBallPath(boatToFire.xP+3, boatToFire.yP+2, boat.xP+2 + rand.Next(boat.image[0].Length-4), boat.yP + rand.Next(2,4)));
                    balls.Add((Animation)buffer.items[buffer.items.Count - 1]);
                    fireCt = Math.Max(2*rand.Next(fireMin, fireMax) / enemies.Count, fireMin);
                    boatToFire = enemies[rand.Next(enemies.Count - 1)];
                }
            }
        }
    }
}
