﻿using System;
using Graphics;
using System.Diagnostics;
using System.Threading;
using System.Collections.Generic;

namespace Menus
{
    public partial class Game : GameLayer
    {
        /// <summary>
        /// Sets the level to be played
        /// </summary>
        /// <param name="i"></param>
        private void setLevel(int i)
        {
            balls = new List<Animation>();
            enemies = new List<Sprite>();
            subs = new List<Sub>();
            buffer = new Layer();
            Sprite temp;
            Sprite temp1;
            Sprite temp2;
            Sprite temp3;
            Sprite temp4;
            Sprite temp5;
            Sprite temp6;
            Sprite temp7;
            Sprite temp9;
            Sub s1, s2, s3, s4, s5;
            resetLevelScore();

            cursor1 = new Still(@"Graphics\Library\Cursor2", 40, 4);

            msg.dataI = level;
            RuskyRaiders.Program.menu[6].runLayer(msg);

            switch (i)
            {
                case 1:
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    temp = new Still(@"Graphics\Library\Boats\Boat_Russian_R", 70, 25); 
                    temp.health = 3;
                    temp.points = 25;
                    temp.flipped = false;
                    enemies.Add(temp);

                    //Add to buffer
                    buffer.add(boat);
                    
                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;
                case 2:
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    temp = new Still(@"Graphics\Library\Boats\Boat_Russian_R", 70, 25); 
                    temp.health = 3;
                    temp.points = 25;
                    enemies.Add(temp);
                    temp1 = new Still(@"Graphics\Library\Boats\Boat_Russian_R", 90, 45); 
                    temp1.health = 3;
                    temp1.points = 25;
                    enemies.Add(temp1);

                    //Add to buffer
                    buffer.add(boat);
                    
                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;
                case 3:
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    temp = new Still(@"Graphics\Library\Boats\Boat_French_R", 70, 25); 
                    temp.health = 3;
                    temp.points = 25;
                    temp.speed = 8;
                    enemies.Add(temp);


                    //Add to buffer
                    buffer.add(boat);
                    
                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;
                case 4:
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    temp = new Still(@"Graphics\Library\Boats\Boat_French_R", 62, 35); 
                    temp.health = 3;
                    temp.points = 25;
                    temp.speed = 8;
                    enemies.Add(temp);
                    temp1 = new Still(@"Graphics\Library\Boats\Boat_French_R", 95, 41); 
                    temp1.health = 3;
                    temp1.points = 25;
                    temp1.speed = 8;
                    enemies.Add(temp1);

                    //Add to buffer
                    buffer.add(boat);
                    
                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;
                case 5:
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    temp = new Still(@"Graphics\Library\Boats\Boat_Russian_R", 60, 25); 
                    temp.health = 3;
                    temp.points = 25;
                    enemies.Add(temp);
                    temp1 = new Still(@"Graphics\Library\Boats\Boat_Russian_R", 90, 45); 
                    temp1.health = 3;
                    temp1.points = 25;
                    enemies.Add(temp1);                    
                    temp2 = new Still(@"Graphics\Library\Boats\Boat_French_R", 12, 41); 
                    temp2.health = 3;
                    temp2.points = 25;
                    temp2.speed = 8;
                    enemies.Add(temp2);

                    //Add to buffer
                    buffer.add(boat);
                    
                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;
                case 6:
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    temp = new Still(@"Graphics\Library\Boats\Boat_French_R", 62, 35); 
                    temp.health = 3;
                    temp.points = 25;
                    temp.speed = 8;
                    enemies.Add(temp);
                    temp1 = new Still(@"Graphics\Library\Boats\Boat_French_R", 95, 41); 
                    temp1.health = 3;
                    temp1.points = 25;
                    temp1.speed = 8;
                    enemies.Add(temp1);
                    temp2 = new Still(@"Graphics\Library\Boats\Boat_French_R", 70, 5); 
                    temp2.health = 3;
                    temp2.points = 25;
                    temp2.speed = 8;
                    enemies.Add(temp2);

                    //Add to buffer
                    buffer.add(boat);
                    
                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;
                case 7:
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    temp = new Still(@"Graphics\Library\Boats\Boat_Russian_L", 62, 35);
                    temp.health = 3;
                    temp.points = 25;
                    enemies.Add(temp);
                    temp1 = new Still(@"Graphics\Library\Boats\Boat_French_R", 95, 41);
                    temp1.health = 3;
                    temp1.points = 25;
                    temp1.speed = 8;
                    enemies.Add(temp1);
                    temp2 = new Still(@"Graphics\Library\Boats\Boat_French_R", 70, 5);
                    temp2.health = 3;
                    temp2.points = 25;
                    temp2.speed = 8;
                    enemies.Add(temp2);
                    temp3 = new Still(@"Graphics\Library\Boats\Boat_Russian_R", 10, 48);
                    temp3.health = 3;
                    temp3.points = 25;
                    enemies.Add(temp3);

                    //Add to buffer
                    buffer.add(boat);
                    
                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;
                case 8:
                     
                    fire = true;

                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    s1 = new Sub(100, 52, false);
                    s1.health = 3;
                    s1.points = 50;
                    s1.speed = 10;
                    s1.flipped = true;
                    subs.Add(s1);
                    enemies.Add((Sprite) s1);

                    //Add to buffer
                    buffer.add(boat);
                    
                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;
                case 9:
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    s1 = new Sub(100, 52, false);
                    s1.health = 3;
                    s1.points = 50;
                    s1.speed = 10;
                    s1.flipped = true;
                    subs.Add(s1);
                    enemies.Add((Sprite)s1);
                    temp2 = new Still(@"Graphics\Library\Boats\Boat_French_R", 70, 5);
                    temp2.health = 3;
                    temp2.points = 25;
                    temp2.speed = 8;
                    enemies.Add(temp2);

                    //Add to buffer
                    buffer.add(boat);
                    
                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;
                case 10:
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    s1 = new Sub(100, 52, false);
                    s1.health = 3;
                    s1.points = 50;
                    s1.speed = 10;
                    s1.flipped = true;
                    subs.Add(s1);
                    enemies.Add((Sprite)s1);
                    s2 = new Sub(75, 19, false);
                    s2.health = 3;
                    s2.points = 50;
                    s2.speed = 10;
                    s2.flipped = true;
                    subs.Add(s2);
                    enemies.Add((Sprite)s2);

                    //Add to buffer
                    buffer.add(boat);
                    
                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;
                case 11:
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    temp = new Still(@"Graphics\Library\Boats\Boat_Russian_L", 62, 35);
                    temp.health = 3;
                    temp.points = 25;
                    enemies.Add(temp);

                    //Add to buffer
                    buffer.add(boat);
                    
                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;
                case 12:
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    temp = new Still(@"Graphics\Library\Boats\Boat_French_L", 82, 45);
                    temp.health = 3;
                    temp.points = 25;
                    temp.speed = 8;
                    enemies.Add(temp);

                    //Add to buffer
                    buffer.add(boat);
                    
                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;
                case 13:
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    s1 = new Sub(100, 52, false);
                    s1.health = 3;
                    s1.points = 50;
                    s1.speed = 10;
                    s1.flipped = true;
                    subs.Add(s1);
                    enemies.Add((Sprite)s1);

                    //Add to buffer
                    buffer.add(boat);
                    
                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;
                case 14:
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    temp1 = new Still(@"Graphics\Library\Boats\Boat_French_L", 82, 45);
                    temp1.health = 3;
                    temp1.points = 25;
                    temp1.speed = 50;
                    enemies.Add(temp1);

                    //Add to buffer
                    buffer.add(boat);

                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;
                case 15:
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    s1 = new Sub(100, 52, false);
                    s1.health = 3;
                    s1.points = 50;
                    s1.speed = 10;
                    s1.flipped = true;
                    subs.Add(s1);
                    enemies.Add((Sprite)s1);

                    temp1 = new Still(@"Graphics\Library\Boats\Boat_French_L", 20, 45);
                    temp1.health = 3;
                    temp1.points = 25;
                    temp1.speed = 8;
                    enemies.Add(temp1);

                    temp2 = new Still(@"Graphics\Library\Boats\Boat_Russian_L", 80,5);
                    temp2.health = 3;
                    temp2.points = 25;
                    enemies.Add(temp2);

                    //Add to buffer
                    buffer.add(boat);
                    
                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;
                case 16:
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 50);
                    //Set Enemies
                    temp2 = new Still(@"Graphics\Library\Boats\Boat_Russian_L", 97, 50);
                    temp2.health = 3;
                    temp2.points = 25;
                    enemies.Add(temp2);
                    //Missle
                    Animation a = new Animation(@"Graphics\Library\bomb_L");
                    
                    int x = 92;
                    int y = 48;
                    int m = 15;
                    int n = 5;
                    for (int c = 0; c < 400; c++)
                    {
                        a.xPs.Add(x+(c*(m-x)/400));
                        double d = (y-n)*Math.Sqrt(c)/20.0;
                        a.yPs.Add((int) (y-d));
                    }
                    a.repeat = false;
                    a.flipped = true;
                    cursor2 = a;
                    cursor2.health = 10;
                    enemies.Add(cursor2);

                    //Add to buffer
                    buffer.add(boat);
                    buffer.add(new Still(@"Graphics\Library\NY",0,2));

                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;
                case 17:
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    temp = new Still(@"Graphics\Library\Boats\Boat_Russian_L", 130, 15);
                    temp.health = 3;
                    temp.points = 25;
                    enemies.Add(temp);
                    temp1 = new Still(@"Graphics\Library\Boats\Boat_Russian_L", 62, 35);
                    temp1.health = 3;
                    temp1.points = 25;
                    enemies.Add(temp1);
                    temp2 = new Still(@"Graphics\Library\Boats\Boat_Russian_R", 2, 50);
                    temp2.health = 3;
                    temp2.points = 25;
                    enemies.Add(temp2);
                    temp3 = new Still(@"Graphics\Library\Boats\Boat_Russian_L", 10, 45);
                    temp3.health = 3;
                    temp3.points = 25;
                    enemies.Add(temp3);
                    temp4 = new Still(@"Graphics\Library\Boats\Boat_Russian_R", 121, 49);
                    temp4.health = 3;
                    temp4.points = 25;
                    enemies.Add(temp4);
                    temp5 = new Still(@"Graphics\Library\Boats\Boat_Russian_L", 55, 20);
                    temp5.health = 3;
                    temp5.points = 25;
                    enemies.Add(temp5);
                    temp6 = new Still(@"Graphics\Library\Boats\Boat_Russian_R", 80, 2);
                    temp6.health = 3;
                    temp6.points = 25;
                    enemies.Add(temp6);
                    temp7 = new Still(@"Graphics\Library\Boats\Boat_Russian_L", 90, 35);
                    temp7.health = 3;
                    temp7.points = 25;
                    enemies.Add(temp7);
                    fireMax = 250;
                    fireMin = 20;

                    //Add to buffer
                    buffer.add(boat);
                    
                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;
                case 18: 
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    temp = new Still(@"Graphics\Library\Boats\Boat_French_L", 102, 45);
                    temp.health = 3;
                    temp.points = 25;
                    temp.speed = 8;
                    enemies.Add(temp);
                    temp1 = new Still(@"Graphics\Library\Boats\Boat_French_R", 60, 52);
                    temp1.health = 3;
                    temp1.points = 25;
                    temp1.speed = 8;
                    enemies.Add(temp1);
                    temp2 = new Still(@"Graphics\Library\Boats\Boat_French_L", 82, 1);
                    temp2.health = 3;
                    temp2.points = 25;
                    temp2.speed = 8;
                    enemies.Add(temp2);
                    temp3 = new Still(@"Graphics\Library\Boats\Boat_French_R", 25, 34);
                    temp3.health = 3;
                    temp3.points = 25;
                    temp3.speed = 8;
                    enemies.Add(temp3);
                    temp4 = new Still(@"Graphics\Library\Boats\Boat_French_L", 5, 52);
                    temp4.health = 3;
                    temp4.points = 25;
                    temp4.speed = 8;
                    enemies.Add(temp4);
                    //Add to buffer
                    buffer.add(boat);
                    

                    fireMax = 200;
                    fireMin = 10;

                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;

                case 19:
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    s1 = new Sub(100, 42, false);
                    s1.health = 3;
                    s1.points = 50;
                    s1.speed = 10;
                    s1.flipped = true;
                    subs.Add(s1);
                    enemies.Add((Sprite)s1);

                    s2 = new Sub(112, 2, false);
                    s2.health = 3;
                    s2.points = 50;
                    s2.speed = 10;
                    s2.flipped = true;
                    subs.Add(s2);
                    enemies.Add((Sprite)s2);

                    s3 = new Sub(105, 52, false);
                    s3.health = 3;
                    s3.points = 50;
                    s3.speed = 10;
                    s3.flipped = true;
                    subs.Add(s3);
                    enemies.Add((Sprite)s3);

                    s4 = new Sub(90, 31, false);
                    s4.health = 3;
                    s4.points = 50;
                    s4.speed = 10;
                    s4.flipped = true;
                    subs.Add(s4);
                    enemies.Add((Sprite)s4);

                    s5 = new Sub(75, 14, false);
                    s5.health = 3;
                    s5.points = 50;
                    s5.speed = 10;
                    s5.flipped = true;
                    subs.Add(s5);
                    enemies.Add((Sprite)s5);        

                    //Add to buffer
                    buffer.add(boat);
                    
                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;

                case 20:
                    //Set USA Boat
                    boat = new Still(@"Graphics\Library\Boats\Boat_USA_R", 2, 2);
                    //Set Enemies
                    temp = new Still(@"Graphics\Library\Boats\Boat_Russian_L", 130, 15);
                    temp.health = 3;
                    temp.points = 25;
                    enemies.Add(temp);
                    temp1 = new Still(@"Graphics\Library\Boats\Boat_Russian_L", 62, 35);
                    temp1.health = 3;
                    temp1.points = 25;
                    enemies.Add(temp1);
                    temp2 = new Still(@"Graphics\Library\Boats\Boat_Russian_R", 2, 50);
                    temp2.health = 3;
                    temp2.points = 25;
                    enemies.Add(temp2);
                    temp3 = new Still(@"Graphics\Library\Boats\Boat_Russian_L", 10, 45);
                    temp3.health = 3;
                    temp3.points = 25;
                    enemies.Add(temp3);
                    temp4 = new Still(@"Graphics\Library\Boats\Boat_Russian_R", 121, 35);
                    temp4.health = 3;
                    temp4.points = 25;
                    enemies.Add(temp4);
                    temp5 = new Still(@"Graphics\Library\Boats\Boat_French_R", 25, 34);
                    temp5.health = 3;
                    temp5.points = 25;
                    temp5.speed = 8;
                    enemies.Add(temp5);
                    temp6 = new Still(@"Graphics\Library\Boats\Boat_French_L", 45, 52);
                    temp6.health = 3;
                    temp6.points = 25;
                    temp6.speed = 8;
                    enemies.Add(temp6);

                    s1 = new Sub(112, 2, false);
                    s1.health = 3;
                    s1.points = 50;
                    s1.speed = 10;
                    s1.flipped = true;
                    subs.Add(s1);
                    enemies.Add((Sprite)s1);
                    enemies.Add(temp);

                    s2 = new Sub(105, 47, false);
                    s2.health = 3;
                    s2.points = 50;
                    s2.speed = 10;
                    s2.flipped = true;
                    subs.Add(s2);
                    enemies.Add((Sprite)s2);
                    enemies.Add(temp);

                    temp9 = new Still(@"Graphics\Library\Moscow");
                    temp9.xP = 120 - temp9.image[0].Length;
                    temp9.yP = 60 - temp9.image.Length;
                    temp9.health = 20;
                    temp9.points = 5000;
                    temp9.speed = 1;
                    enemies.Add(temp9);


                    //Add to buffer
                    buffer.add(boat);
                    
                    foreach (Sprite s in enemies)
                        buffer.add(s);
                    break;
            }

            //Set Aimer
            buffer.add(cursor1);
            //Set time
            if (timeEnforced)
                time = time + 15;
            if (level >= 14)
                time = time + 5;
            buffer.add(scoreDis);
        }
    }
}
