﻿using System;
using Graphics;
using System.Collections.Generic;
using System.Threading;
using System.Diagnostics;

namespace Menus
{
    public class HighScore : GameLayer
    {
        //protected Layer buffer;
        //protected Sprite cursor1;
        //protected Sprite cursor2;
        //protected bool exit = false;
        //public LayerArgs msg = new LayerArgs();
        public static string[] scores;
        public static Stopwatch lastfetch = new Stopwatch();
        public Thread getScores = new Thread(new ThreadStart(get));

        public HighScore()
        {
            buffer = new Layer();
            buffer.add(new Word("High Scores", 1, 1));
            buffer.add(new Word("-------------", 0, 2));
            buffer.add(new Word(" Rank   Name                 Score           Time Left   Hits   Misses   Accuracy   Boats   Germans   French   Russians ", 0, 4));
            buffer.add(new Word("------ -------------------- --------------- ----------- ------ -------- ---------- ------- --------- -------- ----------", 0, 5));
            buffer.add(new Word("---------------------------", 0, 58));
            buffer.add(new Word("Press 'Esc' to continue...", 0, 59));
            cursor1 = new Animation(@"Graphics\Library\Cursor1");
            buffer.add(cursor1);
            cursor1.xP = 97;
            cursor1.yP = 57;
            cursor2 = new Word("Loading High Scores", 101, 58);
            buffer.add(cursor2);
            getScores.Start();
        }

        public static void get()
        {
            lastfetch.Reset();
            scores = HighScores.HighScoreClient.getHighScores();
            lastfetch.Start();
        }

        public override void runLayer(LayerArgs sender)
        {
            Console.Clear();
            buffer.image = new char[120, 60];
            bool exit = false;

            //Print to screen
            buffer.readyPrint();
            buffer.print();

            //Wait for new data... exit if Esc is pressed
            cursor1.yP = 57;
            cursor2.yP = 58;
            while (getScores.ThreadState.Equals(System.Threading.ThreadState.Running))
            {
                if (Console.KeyAvailable)
                    if (readmsg())
                        return;
                Thread.Sleep(40);
                buffer.readyPrint();
                buffer.print();
            }
            cursor1.yP = -10;
            cursor2.yP = -10;
            buffer.readyPrint();
            buffer.print();

            while (!exit)
            { //Begin Loop

                if (Console.KeyAvailable)
                    if (readmsg())
                        return;

                Thread.Sleep(80);

                //Is there data?
                if (scores == null)
                { 
                    //No

                    //Wait for new data... exit if Esc is pressed
                    cursor1.yP = 57;
                    cursor2.yP = 58;

                    while (getScores.ThreadState.Equals(System.Threading.ThreadState.Running))
                    {
                        if (Console.KeyAvailable)
                            if (readmsg())
                                return;
                        Thread.Sleep(40);
                        buffer.readyPrint();
                        buffer.print();
                    }

                }
                else
                {
                    //Yes

                    //Is it old?
                    if (lastfetch.Elapsed.Seconds > 10)
                    {
                        //Yes
                        cursor1.yP = 57;
                        cursor2.yP = 58;

                        getScores.Abort();
                        getScores = new Thread(new ThreadStart(get));
                        getScores.Start();

                        //Print old data
                        if (!printScores())
                            return;

                        //Wait for new data... exit if Esc is pressed
                        while (getScores.ThreadState.Equals(System.Threading.ThreadState.Running))
                        {
                            if (Console.KeyAvailable)
                                if (readmsg())
                                    return;
                            Thread.Sleep(40);
                            buffer.readyPrint();
                            buffer.print();
                        }

                        cursor1.yP = -10;
                        cursor2.yP = -10;
                        buffer.readyPrint();
                        buffer.print();
                    }
                    else
                    { 
                        //No
                        cursor1.yP = -10;
                        cursor2.yP = -10;
                        buffer.readyPrint();
                        buffer.print();

                        //Print old data
                        if (!printScores())
                            return;
                    }
                }

            } //End Loop
        }

        private bool readmsg()
        {
            ConsoleKey k = ConsoleKey.A;
            while(Console.KeyAvailable)
                k = Console.ReadKey(true).Key;
            
            switch (k)
            {
                case ConsoleKey.Escape:
                    return true;
                case ConsoleKey.M:
                    Sound.Player.mute = !Sound.Player.mute;
                    break;
                case ConsoleKey.N:
                    if (Sound.Player.availableSoundCard) 
                        Sound.Player.useSoundCard = !Sound.Player.useSoundCard;
                    break;
            }

            return false;
        }

        private bool printScores()
        {
            int i = 6;
            foreach (string s in scores)
            {
                Console.SetCursorPosition(0, i++);
                if (i % 2 == 0)
                    Console.ForegroundColor = ConsoleColor.DarkGray;
                else
                    Console.ForegroundColor = ConsoleColor.Gray;

                Console.WriteLine(s);

                if (Console.KeyAvailable)
                    if (readmsg())
                        return false;

                Thread.Sleep(80);
            }

            Console.ForegroundColor = Graphics.Defaults.defaultForeground;
            return true;
        }
    }
}