﻿using System;
using Graphics;
using System.Threading;
using System.Diagnostics;
using System.Collections.Generic;

namespace Menus
{
    public class LevelBegin : GameLayer
    {
        //protected Layer buffer;
        //protected Sprite cursor1;
        //protected Sprite cursor2;
        //protected bool exit = false;
        //public LayerArgs msg = new LayerArgs();
        private Thread text;
        private static int x;
        private static int y;
        private static string[] stuff = new string[0];

        public LevelBegin()
        {buffer = new Layer();}

        public override void runLayer(LayerArgs sender)
        {
            setLevel(sender.dataI);

            if (exit)
            {
                if (text != null)
                    if (!text.ThreadState.Equals(System.Threading.ThreadState.Stopped))
                    {
                    text.Abort();
                    Console.CursorVisible = false;
                    }
                return;
            }

            buffer.image = new char[120, 60];
            buffer.readyPrint();
            buffer.print();

            text = new Thread(new ThreadStart(printText));
            text.Start();

            while (!exit)
            { //Begin Loop
                if (Console.KeyAvailable)
                {
                    switch (Console.ReadKey(true).Key)
                    {
                        case ConsoleKey.M:
                            Sound.Player.mute = !Sound.Player.mute;
                            break;
                        case ConsoleKey.N:
                            if (Sound.Player.availableSoundCard)
                                Sound.Player.useSoundCard = !Sound.Player.useSoundCard;
                            break;
                        case ConsoleKey.Escape:
                        case ConsoleKey.Enter:
                        case ConsoleKey.Spacebar:
                            msg.nextLayerIndex = 0;
                            if (text != null)
                                if (!text.ThreadState.Equals(System.Threading.ThreadState.Stopped))
                                {
                                    text.Abort();
                                    Console.CursorVisible = false;
                                }
                            return;
                    }
                }

                Thread.Sleep(40);
            } //End Loop

            if (!text.ThreadState.Equals(System.Threading.ThreadState.Stopped))
                text.Abort();
        }

        /// <summary>
        /// Setup each level where you want a storyboard intro
        /// </summary>
        /// <param name="i"></param>
        private void setLevel(int i)
        {
            Console.Clear();
            string longblank = "                                                                                                                        ";
            exit = false;
            buffer.add(new Still(@"Graphics\Library\Patriot", 4, 2));
            x = 5;
            y = 30;

            switch (i)
            {
                case 1:
                    //Set Text
                    stuff = new string[2];
                    stuff[0] = "Welcome, Captain.  Please enter your name.";
                    stuff[1] = "  Please enter your name: ";
                    RuskyRaiders.Program.name = "";

                    Console.Clear();
                    buffer.image = new char[120, 60];
                    buffer.readyPrint();
                    buffer.print();
                    printText();

                    while (RuskyRaiders.Program.name == "" || RuskyRaiders.Program.name.Length > 19)
                    {
                        //Get user's name
                        while (Console.KeyAvailable)
                            Console.ReadKey(true);

                        RuskyRaiders.Program.name = Console.ReadLine();

                        Console.SetCursorPosition(5, 30);
                        Console.Write(longblank + longblank + longblank+longblank+longblank+longblank+longblank+longblank+longblank+longblank+longblank+longblank);

                        if (RuskyRaiders.Program.name == "")
                        {
                            stuff[0] = "ah... won't give me your name?! hmmm...";
                            stuff[1] = "TRAITOR!  GET THIS COMMI SPY OUT OF HERE!";
                            printText();
                            Thread.Sleep(2500);
                            Console.SetCursorPosition(5, 30);
                            Console.Write(longblank + longblank + longblank);
                            stuff[0] = "hah! Just kidding. Now won't you give me your name?";
                            stuff[1] = "  Please enter your name: ";
                            printText();
                        }
                        else if (RuskyRaiders.Program.name.Length > 19)
                        {
                            stuff[0] = "Really?  Don't you have a nick name or something shorter?";
                            stuff[1] = "  Please enter your name: ";
                            printText();
                        }
                    }

                    while (Console.KeyAvailable)
                        Console.ReadKey(true);

                    stuff = new string[7];
                    stuff[0] = "Captain " + RuskyRaiders.Program.name + ",";
                    stuff[1] = " We need your help. Our sentries have spotted unauthorized ships off the ";
                    stuff[2] = "Atlantic Coast. They appear to be Ruskies.  We are going to need you to ";
                    stuff[3] = "go check it out and see what's going.";
                    stuff[4] = "";
                    stuff[5] = "Good Luck,";
                    stuff[6] = "-The President";

                    return;
                case 5:
                    //Set Text
                    stuff = new string[6];
                    
                    stuff[0] = "Ruskies and the French? What is going on?";
                    stuff[1] = " Our satelites have picked up more ships heading this way. Captain " + RuskyRaiders.Program.name + ",";
                    stuff[2] = "why don't you go meet them halfway and see what's going on.";
                    stuff[3] = "";
                    stuff[4] = "Best of Luck,";
                    stuff[5] = "-The President";

                    return;
                case 8:
                    //Set Text
                    stuff = new string[11];

                    stuff[0] = "That's a lot of Ruskies! And that many French in one place usually ";
                    stuff[1] = "only means one thing...";
                    stuff[2] = "";
                    stuff[3] = "Retreat!";
                    stuff[4] = "";
                    stuff[5] = "That many Ruskies and French together can only mean war.";
                    stuff[6] = "Why don't you sail over there and see if you can find out anything"; 
                    stuff[7] = "useful. Try and use diplomacy.";
                    stuff[8] = "";
                    stuff[9] = "We are counting on you Captain " + RuskyRaiders.Program.name + ",";
                    stuff[10] = "-The President";

                    return;
                case 11:
                    //Set Text
                    stuff = new string[5];

                    stuff[0] = "French, Ruskies, and the Germans? This could be really bad. ";
                    stuff[1] = "Captain " + RuskyRaiders.Program.name + ", you need to hustle back here. We have incoming!";
                    stuff[2] = "Our southeastern ports are under attack!";
                    stuff[3] = "";
                    stuff[4] = "-The President";

                    return;


                case 16:
                    //Set Text
                    stuff = new string[6];

                    stuff[0] = "Captain " + RuskyRaiders.Program.name + ",";
                    stuff[1] = "We have intercepted a message indicating that the Ruskies plan on destroying New York.";
                    stuff[2] = "The entire city is counting on you.";
                    stuff[3] = "";
                    stuff[4] = "You must stop them!";
                    stuff[5] = "-The President";

                    return;

                case 17:
                    //Set Text
                    stuff = new string[5];

                    stuff[0] = "Captain " + RuskyRaiders.Program.name + ",";
                    stuff[1] = "I've had it with all of their uncalled-for attacks!";
                    stuff[2] = "It's about time we got some payback! Let's go after  their fleet!";
                    stuff[3] = "";
                    stuff[4] = "-The President";

                    return;
                case 20:
                    //Set Text
                    stuff = new string[6];

                    stuff[0] = "Captain " + RuskyRaiders.Program.name + ",";
                    stuff[1] = "Great Work! The American people are proud of you.";
                    stuff[2] = "Let's go ahead and send a message.....";
                    stuff[3] = "We're going after Moscow!";
                    stuff[4] = "";
                    stuff[5] = "-The President";

                    return;
            }

            exit = true;

        }

        private static void printText()
        {Graphics.Defaults.printText(stuff, x, y, 5);}
    }
}