﻿using System;
using Graphics;
using System.Threading;
using System.Diagnostics;
using System.Collections.Generic;

namespace Menus
{
    public class LevelComplete : GameLayer
    {
        //protected Layer buffer;
        //protected Sprite cursor1;
        //protected Sprite cursor2;
        //protected bool exit = false;
        //public LayerArgs msg = new LayerArgs();
        List<Sprite> bck;
        public bool end = false;

        public LevelComplete()
        {
            bck = MainMenu.animations;
        }

        public override void runLayer(LayerArgs sender)
        {
            bool cont = false;

            end = sender.dataS.Contains("Failure");
            Console.Clear();
            Stopwatch clock = new Stopwatch();
            buffer = new Layer();
            if (end)
            {
                buffer.add(new Still(@"Graphics\Library\Patriot", 0, 41));
                buffer.add(new Word("Would you like to continue playing?  If so, your", 60, 3));
                buffer.add(new Word("time and score will be reset, but you will be able", 60, 4));
                buffer.add(new Word("to continue at the start of the level.", 60, 5));
                buffer.add(new Word("Submit High Score...", 65, 7));
                buffer.add(new Word("Continue...", 65, 9));
                cursor1 = new Word("*", 63, 7);
                buffer.add(cursor1);
            }
            else
                buffer.add(bck);
            buffer.add(new Word(sender.dataS, 1, 1));
            buffer.add(new Word("---------------------------".Substring(0, sender.dataS.Length), 1, 2));
            buffer.add(new Word("Level " + sender.dataI + " Stats" + "              ".Substring(0, 14-Convert.ToString(sender.dataI).Length) + "Game Stats", 1, 4));
            buffer.add(new Word("---------------------    ---------------------- ", 1, 5));
                  
              
            //Score Animation
            printScore((Game.alldata)sender.obj, sender.dataI);
            buffer.image = new char[120, 60];
            bool exit = false;
            buffer.readyPrint();
            buffer.print();

            //Failure messages
            displayFailure(sender.dataI);

            while (Console.KeyAvailable)
                Console.ReadKey(true);

            int counter=40; //1 sec pause before allowed to continue

            while (!exit)
            { //Begin Loop
                if (Console.KeyAvailable)
                {
                    switch (Console.ReadKey(true).Key)
                    {
                        case ConsoleKey.M:
                            Sound.Player.mute = !Sound.Player.mute;
                            break;
                        case ConsoleKey.N:
                            if (Sound.Player.availableSoundCard)
                                Sound.Player.useSoundCard = !Sound.Player.useSoundCard;
                            break;
                        case ConsoleKey.Escape:
                        case ConsoleKey.Enter:
                        case ConsoleKey.Spacebar:
                            if (counter == 0)
                                return;
                            break;
                        case ConsoleKey.UpArrow:
                            if (end)
                                cont = !cont;
                            break;
                        case ConsoleKey.DownArrow:
                            if (end)
                                cont = !cont;
                            break;
                    }
                }
                counter = Math.Max(0,counter-1);

                if (end)
                {//Adjust cursor position
                    if (cont)
                    {
                        cursor1.yP = 9;
                        sender.nextLayerIndex = 1;
                    }
                    else
                    {
                        cursor1.yP = 7;
                        sender.nextLayerIndex = 4;
                    }
                }

                //Print buffer to screen
                buffer.readyPrint();
                clock.Stop();
                if (clock.Elapsed.Milliseconds < 30)
                    Thread.Sleep(30 - clock.Elapsed.Milliseconds);
                clock.Reset();
                clock.Start();
                buffer.print();
            } //End Loop

        }

        private void printScore(Game.alldata scores, int level)
        {
            Still bckgrd = new Still();
            bckgrd.xP = 1;
            bckgrd.yP = 6;
            bckgrd.image = new string[10];

            if (scores.lev.fired == scores.lev.hits && scores.lev.hits>0)
            {   
                scores.lev.totalpts += 50;
                scores.tot.totalpts += 50;
                bckgrd.image[8] = "Accuracy Bonus!  +" + 50;
            }
            else if (scores.lev.fired > 30)
            {
                bckgrd.image[8] = "RAMPAGE Bonus!" + "     ".Substring(Convert.ToString(scores.lev.fired).Length) + "+" + scores.lev.fired;
            }



            bckgrd.image[0] = "Russian" + "             ".Substring((scores.lev.russians + "").Length) + scores.lev.russians;
            bckgrd.image[1] = "French" + "              ".Substring((scores.lev.french + "").Length) + scores.lev.french;
            bckgrd.image[2] = "German" + "              ".Substring((scores.lev.germans + "").Length) + scores.lev.germans;
            bckgrd.image[3] = "Boats" + "               ".Substring((scores.lev.boats + "").Length) + scores.lev.boats;

            bckgrd.image[5] = "Hits" + "                ".Substring((scores.lev.hits + "").Length) + scores.lev.hits;
            int miss = scores.lev.fired - scores.lev.hits;
            bckgrd.image[6] = "Misses" + "              ".Substring((miss + "").Length) + miss;
            double acc = Math.Round(100.0 * scores.lev.hits / scores.lev.fired, 1);
            bckgrd.image[7] = "Accuracy" + "            ".Substring((acc + "").Length) + acc + "%";

            bckgrd.image[9] = "Points" + "              ".Substring((scores.lev.totalpts + "").Length) + scores.lev.totalpts;

            buffer.add(bckgrd);




            Still bckgrd2 = new Still();
            bckgrd2.xP = 27;
            bckgrd2.yP = 6;
            bckgrd2.image = new string[10];

            if (scores.tot.fired == scores.tot.hits && scores.lev.hits > 0)
            {
                scores.tot.totalpts += 50 * level;
                bckgrd2.image[8] = "Accuracy Bonus! +" + 50 * level;
                if (level == 1)
                    bckgrd2.image[8] = "Accuracy Bonus!  +" + 50;
            }
            if (level == 20 && ((Game)RuskyRaiders.Program.menu[1]).time > 0)
            {
                bckgrd2.image[8] = "Time Bonus!"+"         ".Substring(0,8-Convert.ToString(((Game)RuskyRaiders.Program.menu[1]).time * 250).Length)+"+" + ((Game)RuskyRaiders.Program.menu[1]).time * 250;
                scores.tot.totalpts += ((Game)RuskyRaiders.Program.menu[1]).time * 250;
            }

            bckgrd2.image[0] = "Russian" + "             ".Substring((scores.tot.russians + "").Length) + scores.tot.russians;
            bckgrd2.image[1] = "French" + "              ".Substring((scores.tot.french + "").Length) + scores.tot.french;
            bckgrd2.image[2] = "German" + "              ".Substring((scores.tot.germans + "").Length) + scores.tot.germans;
            bckgrd2.image[3] = "Boats" + "               ".Substring((scores.tot.boats + "").Length) + scores.tot.boats;

            bckgrd2.image[5] = "Hits" + "                ".Substring((scores.tot.hits + "").Length) + scores.tot.hits;
            int miss2 = scores.tot.fired - scores.tot.hits;
            bckgrd2.image[6] = "Misses" + "              ".Substring((miss2 + "").Length) + miss2;
            double acc2 = Math.Round(100.0 * scores.tot.hits / scores.tot.fired, 1);
            bckgrd2.image[7] = "Accuracy" + "            ".Substring((acc2 + "").Length) + acc2 + "%";

            bckgrd2.image[9] = "Points" + "              ".Substring((scores.tot.totalpts + "").Length) + scores.tot.totalpts;

            buffer.add(bckgrd2);



            if (scores.tot.fired == scores.tot.hits && scores.lev.hits > 0)
                buffer.add(new Animation(@"Graphics\Library\bonus", 27, 14));//accuracy bonus
            if (scores.lev.fired == scores.lev.hits && scores.lev.hits > 0)
                buffer.add(new Animation(@"Graphics\Library\bonus", 1, 14));//accuracy bonus
            if (scores.lev.fired > 40)
            {
                buffer.add(new Animation(@"Graphics\Library\bonus2", 1, 14));//rampage bonus
                scores.lev.totalpts += scores.lev.fired;
                scores.tot.totalpts += scores.lev.fired;
            }
            if (level == 20 && ((Game)RuskyRaiders.Program.menu[1]).time > 0)
            {
                buffer.add(new Animation(@"Graphics\Library\bonus3", 27, 14));//rampage bonus
            }
        }

        private void displayFailure(int level)
        {
            if (end)
            {
                Random r = new Random();
                string[] s = new string[4];
                switch (r.Next(4))
                {
                    case 0:
                        s[0] = "You just took too long. I guess I can't trust ";
                        s[1] = "you to get the job done.  You'll be reassigned!";
                        s[2] = "I hear we need a recruiter at the";
                        s[3] = "Pacifist Convention.";
                        break;
                    case 1:
                        s[0] = "You just took too long. I guess I can't trust ";
                        s[1] = "you to get the job done.  You'll be reassigned!";
                        s[2] = "I hear we need a new guard at our Naval base ";
                        s[3] = "in Nebraska.";
                        break;
                    case 2:
                        s[0] = "You just took too long. I guess I can't trust ";
                        s[1] = "you to get the job done.  You'll be reassigned!";
                        s[2] = "I hear we need a paint dryer in Michigan.";
                        s[3] = "";
                        break;
                    case 3:
                        s[0] = "You just took too long. I guess I can't trust ";
                        s[1] = "you to get the job done.  You'll be reassigned!";
                        s[2] = "I hear we need a janitor in the Flu-wing ";
                        s[3] = "of the hospital.";
                        break;
                }
                if (level == 16)
                {//New York is destroyed
                    s[0] = "How could you let them destroy our biggest city?";
                    s[1] = "We're ruined! All you had to do was protect the";
                    s[2] = "city. I think you're one of them. Why don't you ";
                    s[3] = "go back to all of your Red Friends!.";
                }

                Graphics.Defaults.printText(s, 70, 53, 5);
            }
        }
    }
}