﻿using System;
using Graphics;
using System.Threading;
using System.Diagnostics;
using System.Collections.Generic;

namespace Menus
{
    public class MainMenu : GameLayer
    {
        //protected Layer buffer;
        //protected Sprite cursor1;
        //protected Sprite cursor2;
        //protected bool exit = false;
        //public LayerArgs msg = new LayerArgs();
        protected Layer staticBuffer = new Layer();
        public static List<Sprite> animations;
        public MainMenu()
        {
            buffer = new Layer();
            animations = (new MainMenuAnimation()).animations;
            buffer.add(animations);
            staticBuffer.add(new Still(@"graphics\library\title", 10, 1));
            buffer.add(new Word("-- Start Game --", 52, 28));
            buffer.add(new Word("-- Game Options --", 51, 30));
            buffer.add(new Word("-- Tutorial --", 53, 32));
            buffer.add(new Word("-- High Scores --", 51, 34));
            buffer.add(new Word("-- Quit --", 55, 36));
            cursor1 = new Animation(@"graphics\library\menuselector");
            cursor1.xP = 44;
            cursor1.yP = 27;
            buffer.add(cursor1);
        }

        public override void runLayer(LayerArgs sender)
        {
            if (((Game) RuskyRaiders.Program.menu[1]).level > 1)
                buffer.add(new Word(" -- Continue -- ", 52, 28));
            msg.dataI = 1;
            Console.Clear();
            buffer.image = new char[120,60];
            staticBuffer.image = new char[120, 60];
            staticBuffer.readyPrint();
            staticBuffer.print();
            bool exit = false;
            Stopwatch clock = new Stopwatch();
            while (Console.KeyAvailable)
                Console.ReadKey(true);

            while (!exit)
            { //Begin Loop
                if (Console.KeyAvailable)
                {
                    switch (Console.ReadKey(true).Key)
                    {
                        case ConsoleKey.UpArrow:
                            if (--msg.nextLayerIndex == 0)
                                msg.nextLayerIndex = 5;
                            cursor1.yP = 25 + (msg.nextLayerIndex * 2);
                            break;
                        case ConsoleKey.DownArrow:
                            if (++msg.nextLayerIndex == 6)
                                msg.nextLayerIndex = 1;
                            cursor1.yP = 25 + (msg.nextLayerIndex * 2);
                            break;
                        case ConsoleKey.M:
                            Sound.Player.mute = !Sound.Player.mute;
                            break;
                        case ConsoleKey.N:
                            if (Sound.Player.availableSoundCard)
                                Sound.Player.useSoundCard = !Sound.Player.useSoundCard;
                            break;
                        case ConsoleKey.Escape:
                            msg.nextLayerIndex = 5;
                            return;
                        case ConsoleKey.Enter:
                        case ConsoleKey.Spacebar:
                            return;
                    }
                }

                //Print to screen
                buffer.readyPrint();
                clock.Stop();
                if (clock.Elapsed.Milliseconds < 40)
                    Thread.Sleep(40 - clock.Elapsed.Milliseconds);
                clock.Reset();
                clock.Start();
                buffer.print();
            } //End Loop

        }


    }
}