﻿using System;
using Graphics;
using System.Collections.Generic;
using System.Threading;
using System.Diagnostics;

namespace Menus
{
    public class Options : GameLayer
    {
        //protected Layer buffer;
        //protected Sprite cursor1;
        //protected Sprite cursor2;
        //protected bool exit = false;
        //public LayerArgs msg = new LayerArgs();
        int x = 0;


        public Options()
        {
            buffer = new Layer();
            buffer.add(new Word("Game Options", 1, 1));
            buffer.add(new Word("----------------------------------------------", 0, 2));
            buffer.add(new Word(" | |  Enable PC Speaker (toggle with 'S' key)", 0, 4));
            buffer.add(new Word(" | |  Mute (toggle with 'M' key)", 0, 6));
            buffer.add(Menus.MainMenu.animations);
            buffer.add(new Word("---------------------------", 0, 58));
            buffer.add(new Word("Press 'Esc' to continue...", 0, 59));
        }

        public override void runLayer(LayerArgs sender)
        {
            Console.Clear();
            buffer.image = new char[120, 60];
            bool exit = false;

            //Print to screen
            buffer.readyPrint();
            buffer.print();
            update();
            Stopwatch clock = new Stopwatch();

            while (!exit)
            { //Begin Loop

                if (Console.KeyAvailable)
                {
                    switch (Console.ReadKey(true).Key)
                    {
                        case ConsoleKey.UpArrow:
                            x = (x+2-1)%2;
                            update();
                            break;
                        case ConsoleKey.DownArrow:
                            x = (x+1)%2;
                            update();
                            break;
                        case ConsoleKey.Spacebar:
                        case ConsoleKey.LeftArrow:
                        case ConsoleKey.RightArrow:
                            if (x == 0 && Sound.Player.availableSoundCard)
                                Sound.Player.useSoundCard = !Sound.Player.useSoundCard;
                            if (x == 1)
                                Sound.Player.mute = !Sound.Player.mute;
                            update();
                            break;
                        case ConsoleKey.M:
                            Sound.Player.mute = !Sound.Player.mute;
                            update();
                            break;
                        case ConsoleKey.N:
                            if (Sound.Player.availableSoundCard)
                                Sound.Player.useSoundCard = !Sound.Player.useSoundCard;
                            update();
                            break;
                        case ConsoleKey.Escape:
                            return;
                    }
                }

                //Print to screen
                buffer.readyPrint();
                clock.Stop();
                if (clock.Elapsed.Milliseconds < 40)
                    Thread.Sleep(40 - clock.Elapsed.Milliseconds);
                clock.Reset();
                clock.Start();
                buffer.print();
            } //End Loop
        }

        private void update()
        {
            if (x == 0)
            {
                //Clear other marks
                Console.SetCursorPosition(2,6);
                if (Sound.Player.mute)
                    Console.Write("X");
                else
                    Console.Write(" ");

                Console.SetCursorPosition(2,4);
                Console.BackgroundColor = ConsoleColor.DarkGray;
                Console.ForegroundColor = ConsoleColor.White;

                if (!Sound.Player.useSoundCard)
                    Console.Write("X");
                else
                    Console.Write(" ");

                Console.ResetColor();
            }
            else if (x == 1)
            {
                //Clear other marks
                Console.SetCursorPosition(2,4);
                if (!Sound.Player.useSoundCard)
                    Console.Write("X");
                else
                    Console.Write(" ");
                
                Console.SetCursorPosition(2, 6);
                Console.BackgroundColor = ConsoleColor.DarkGray;
                Console.ForegroundColor = ConsoleColor.White;
                
                if (Sound.Player.mute)
                    Console.Write("X");
                else
                    Console.Write(" ");

                Console.ResetColor();
            }
        }

    }
}