﻿using System;
using Graphics;
using System.Collections.Generic;
using System.Threading;
using System.Diagnostics;

namespace Menus
{
    public class QuitSplash : GameLayer
    {
        //protected Layer buffer;
        //protected Sprite cursor1;
        //protected Sprite cursor2;
        //protected bool exit = false;
        //public LayerArgs msg = new LayerArgs();

        public QuitSplash()
        {
            buffer = new Layer();
            buffer.add(new Word(" 'NY and Moscow' by Ryan Olsem ", 89, 59));
            Still ny = new Still(@"Graphics\Library\NY");
            ny.xP = 3;
            ny.yP = 40;
            Still russ = new Still(@"Graphics\Library\Moscow");
            russ.xP = 65;
            russ.yP = 40;
            buffer.add(russ);
            buffer.add(ny);
            buffer.add(new Word("-------------------------------------------------", 0, 58));
            buffer.add(new Word("Press any key to quit, or Backspace to return...", 0, 59));
        }

        public override void runLayer(LayerArgs sender)
        {
            Console.Clear();
            buffer.image = new char[120, 60];
            msg.nextLayerIndex = -1;
            bool exit = false;

            //Print to screen
            buffer.readyPrint();
            buffer.print();

            //Print Credits
            Thread credits = new Thread(new System.Threading.ThreadStart(printCredits));
            credits.Start();

            while (!exit)
            { //Begin Loop

                if (Console.KeyAvailable)
                {
                    ConsoleKey k = Console.ReadKey(true).Key;
                    if (k.Equals(ConsoleKey.Backspace))
                    {
                        msg.nextLayerIndex = 0;
                        exit = true;
                    }
                    else
                    {
                        if (!credits.ThreadState.Equals(System.Threading.ThreadState.Stopped))
                        {
                            credits.Abort();
                            Console.CursorVisible = false;
                        }
                        return;
                    }
                }

            } //End Loop

            if (!credits.ThreadState.Equals(System.Threading.ThreadState.Stopped))
            {
                credits.Abort();
                Console.CursorVisible = false;
            }
        }

        private static void printCredits()
        {
            string[] credits = new string[8];
            credits[0] = "```````````````Thanks for Playing!!";
            credits[1] = "````-------------------------------------------";
            credits[2] = "```````````Lead Developer - Chad Nelson";
            credits[3] = "";
            credits[4] = "Audio Coordinator and Head of Research - Ryan Olsem";
            credits[5] = "`````Director of Arrangements - Sarah Andreesen";
            credits[6] = "````````````Beta Tester - Nick Greiner";
            credits[7] = "`Team India Members - Hasit Desai & Chirant Parikh";

            Graphics.Defaults.printText(credits, 35, 5, 5);
        }
    }
}