﻿using System;
using Graphics;
using System.Collections.Generic;
using System.Threading;
using System.Diagnostics;

namespace Menus
{
    public class Tutorial : GameLayer
    {
        //protected Layer buffer;
        //protected Sprite cursor1;
        //protected Sprite cursor2;
        //protected bool exit = false;
        //public LayerArgs msg = new LayerArgs();

        public Tutorial()
        {
            buffer = new Layer();
            buffer.add(new Word("Tutorial", 1, 1));
            buffer.add(new Word("----------------------------------------------", 0, 2));

            buffer.add(new Word(" ←,↑,→,↓ - Move your mighty American boat.", 0, 4));
            buffer.add(new Word(" A,W,D,S - Move firing cursor", 0, 5));
            buffer.add(new Word(" F, Spacebar - FIRE CANNONBALL!.", 0, 6));
            buffer.add(new Word(" Escape, P - Pause Game", 0, 7));
            buffer.add(new Word(" N - Toggle between soundcard and PC speaker.", 0, 8));
            buffer.add(new Word(" M - Toggle mute/unmute.", 0, 9));

            buffer.add(new Animation(@"Graphics\Library\bonus",  1, 11));
            buffer.add(new Word(" +50 points for each level where you don't miss.", 16, 11));
            buffer.add(new Animation(@"Graphics\Library\bonus2", 1, 13));
            buffer.add(new Word(" +1 points per cannonball fired, only if you fire more than 30 cannonballs", 15, 13));
            buffer.add(new Animation(@"Graphics\Library\bonus3", 1, 15));
            buffer.add(new Word(" +250 points per second left at the end of the game", 12, 15));

            buffer.add(Menus.MainMenu.animations);

            buffer.add(new Word("---------------------------", 0, 58));
            buffer.add(new Word("Press 'Esc' to continue...", 0, 59));
        }

        public override void runLayer(LayerArgs sender)
        {
            Console.Clear();
            buffer.image = new char[120, 60];
            bool exit = false;

            //Print to screen
            buffer.readyPrint();
            buffer.print();
            Stopwatch clock = new Stopwatch();

            while (!exit)
            { //Begin Loop

                if (Console.KeyAvailable)
                {
                    switch (Console.ReadKey(true).Key)
                    {
                        case ConsoleKey.M:
                            Sound.Player.mute = !Sound.Player.mute;
                            break;
                        case ConsoleKey.N:
                            if (Sound.Player.availableSoundCard)
                                Sound.Player.useSoundCard = !Sound.Player.useSoundCard;
                            break;
                        case ConsoleKey.Escape:
                            return;
                    }
                }

                //Print to screen
                buffer.readyPrint();
                clock.Stop();
                if (clock.Elapsed.Milliseconds < 40)
                    Thread.Sleep(40 - clock.Elapsed.Milliseconds);
                clock.Reset();
                clock.Start();
                buffer.print();

            } //End Loop
        }
    }
}