﻿using System;
using System.Threading;
using Graphics;

namespace RuskyRaiders
{
    class Program
    {
        public static string name = "";
        public static Menus.GameLayer[] menu;

        static void Main(string[] args)
        {
            //Set Console Window
            Console.CursorVisible = false;
            Console.SetWindowSize(120,60);
            Console.SetBufferSize(120,60);
            Console.Title = "Ruskie Raiders v2.0";

            //Initialize Sound
            Sound.Player.initialize();

            //Initialize High Scores watcher
            HighScores.HighScoreClient.watch();
            //HighScores.HighScoreClient.highscorestofile();

            //Create Menu System
            menu = createMenus();
            Sound.Player.Music_FileNames.Enqueue("National_Anthem_Russia");
            Menus.GameLayer current = menu[0];
            current.runLayer(null);
            
            //Run Game Loop
            while (current.msg.nextLayerIndex != -1)
            {
                Menus.GameLayer.LayerArgs msg = current.msg;
                current = menu[current.msg.nextLayerIndex];
                current.runLayer(msg);
            }
 
            Environment.Exit(0);
        }

        /// <summary>
        /// Create game menus
        /// </summary>
        /// <returns></returns>
        public static Menus.GameLayer[] createMenus()
        {
            Menus.GameLayer[] layers = new Menus.GameLayer[8];
            Console.WriteLine("Creating Game:");
            layers[0] = new Menus.MainMenu();
            Console.WriteLine(" - Main Menu created");
            layers[0].msg.nextLayerIndex = 1;
            layers[1] = new Menus.Game();
            Console.WriteLine(" - Game Levels created");
            layers[2] = new Menus.Options();
            Console.WriteLine(" - Options created");
            layers[3] = new Menus.Tutorial();
            Console.WriteLine(" - Tutorial created");
            layers[4] = new Menus.HighScore();
            Console.WriteLine(" - High Scores created");
            Console.WriteLine("   - Starting async server fetch...");
            layers[5] = new Menus.QuitSplash();
            Console.WriteLine(" - Quit Splash created");
            layers[6] = new Menus.LevelBegin();
            Console.WriteLine(" - President created");
            layers[7] = new Menus.LevelComplete();
            Console.WriteLine(" - Completion Screens created");
            Animation.setTimeTo20 = false;
            return layers;
        }

    }
}
